package cn.iocoder.yudao.module.pms.dal.mysql.qhse.hazard;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.hazard.vo.IotHazardPageReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.qhse.hazard.IotHazardDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Set;

/**
 * QHSE隐患排查及整改 Mapper
 *
 * @author 超级管理员
 */
@Mapper
public interface IotHazardMapper extends BaseMapperX<IotHazardDO> {

    default PageResult<IotHazardDO> selectPage(IotHazardPageReqVO reqVO, Set<Long> ids) {
        return selectPage(reqVO, new LambdaQueryWrapperX<IotHazardDO>()
                .eqIfPresent(IotHazardDO::getStatus, reqVO.getStatus())
                .eqIfPresent(IotHazardDO::getAddress, reqVO.getAddress())
                .eqIfPresent(IotHazardDO::getProblem, reqVO.getProblem())
                .eqIfPresent(IotHazardDO::getSource, reqVO.getSource())
                .eqIfPresent(IotHazardDO::getHazardFile, reqVO.getHazardFile())
                .eqIfPresent(IotHazardDO::getRectifyDesc, reqVO.getRectifyDesc())
                .eqIfPresent(IotHazardDO::getRectifyFile, reqVO.getRectifyFile())
                .inIfPresent(IotHazardDO::getDeptId, ids)
                .betweenIfPresent(IotHazardDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(IotHazardDO::getRemark, reqVO.getRemark())
                .orderByDesc(IotHazardDO::getId));
    }

    default List<IotHazardDO> selectListByDept(IotHazardPageReqVO reqVO, Set<Long> ids) {
        return selectList(new LambdaQueryWrapperX<IotHazardDO>()
                .eqIfPresent(IotHazardDO::getStatus, reqVO.getStatus())
                .eq(IotHazardDO::getDeleted, false)
                .betweenIfPresent(IotHazardDO::getCreateTime, reqVO.getCreateTime())
                .inIfPresent(IotHazardDO::getDeptId, ids));
    }
}